#include <stdio.h>

void saisirTab(int tab[],int n, int length){
  printf("Saisir des éléments dans [1,%d]\n",n);
  int i,v;
  for(i=0;i<length;i++){
    do{
      printf("%d > ",i);
      scanf("%d",&v);
    }while(v<1 || n<v);
    tab[i]=v;
  }
}

void afficheTab(int tab[],int length){
  int i;
  printf("=> [");
  if(length==0){
    printf("]");
  }
  else{
    printf("\033[32m%d\033[0m",tab[0]);
    for(i=1;i<length;i++){
      printf(",\033[32m%d\033[0m",tab[i]);
    }
    printf("]");
  } 
}

void inverse_avec_tab(int tab[],int length){
  int temp[length];
  int i;
  for(i=0;i<length;++i){
    temp[i]=tab[i];
  }
  int j=length-1;
  for(i=0;i<length;++i){
    tab[i]=temp[j];
    --j;
  }
}

void inverse_sans_tab(int tab[],int length){
  int i=0;
  int j=length-1;
  int temp;
  while(i<j){
    temp=tab[i];
    tab[i]=tab[j];
    tab[j]=temp;
    ++i;
    --j;
  }
}

void teste_symetrique(int tab[],int length){
  int i=0;
  int j=length-1;
  while(i<j){
    if(tab[i]!=tab[j]){
      printf("Tableau non symétrique.\n");
      return;
    }
    ++i;
    --j;
  }
  printf("Tableau symétrique.\n");
}


void compte_multiple(int tab[],int length,int n){
  int nb[n];
  int i;
  for(i=0;i<n;++i){
    nb[i]=0;
  }
  for(i=0;i<length;++i){
    ++nb[tab[i]];
  }
  int nm=0;
  for(i=0;i<n;++i){
    if(nb[i]>1){
      ++nm;
    }
  }
  printf("Il y a %d éléments présent au moins 2 fois.\n",nm);
}

int menu(){
  int choix;
  do{
     printf("\n Choix possible :\n");
     printf("\033[35m1\033[0m -> Saisir les elements\n");
     printf("\033[35m2\033[0m -> Afficher le tableau\n");
     printf("\033[35m3\033[0m -> Inverser le tableau (avec intermediaire)\n");
     printf("\033[35m4\033[0m -> Inverser le tableau (sans intermediaire)\n");
     printf("\033[35m5\033[0m -> Tester si le tableau est symétrique\n");
     printf("\033[35m6\033[0m -> Compter les éléments présent plusieur fois\n");
     printf("\033[35m7\033[0m -> Quitter\n");
     printf("\nQue voulez-vous faire ? ");
     scanf(" %d",&choix);
  }while(choix<1 || choix>7);
   return choix;
}

int main(void){
  int n,length;
  int saisi=0;
  do{
    printf("Valeur de n (>=1) : ");
    scanf("%d",&n);
  }while(n<1);
  do{
    printf("Taille du tableau (dans [1,n]) : ");
    scanf("%d",&length);
  }while(length<1 || n<length);
  int tab[length];
  int choix;
  do{
    printf("\n");
    choix=menu();
    if(choix==1){
      saisirTab(tab,n,length);
      saisi=1;
    }
    else{
      if(saisi==0){
	printf("Tableau non saisi !!!\n");
      }
      else{
	if(choix==2){
	  afficheTab(tab,length);
	}
	if(choix==3){
	  inverse_avec_tab(tab,length);
	}
	if(choix==4){
	  inverse_sans_tab(tab,length);
	}
	if(choix==5){
	  teste_symetrique(tab,length);
	}
	if(choix==6){
	  compte_multiple(tab,length,n);
	}
      }
    }
  }
  while(choix!=7);
}
  
